﻿
Imports System
Imports System.Collections.Generic
Imports System.Diagnostics
Imports System.Linq
Imports System.Net
Imports System.Threading
Imports Microsoft.WindowsAzure
Imports Microsoft.WindowsAzure.Diagnostics
Imports Microsoft.WindowsAzure.ServiceRuntime
Imports Microsoft.WindowsAzure.StorageClient

Public Class WorkerRole
    Inherits RoleEntryPoint
    Public Overrides Sub Run()
        ' This is a sample worker implementation. Replace with your logic.
        Trace.WriteLine("WorkerRole1 entry point called", "Information")

        Do
            Thread.Sleep(New TimeSpan(0, 1, 15))
            Trace.WriteLine("Working", "Information")
            TransferPerfDataToSql()
        Loop
    End Sub

    Public Overrides Function OnStart() As Boolean
        ' Set the maximum number of concurrent connections 
        ServicePointManager.DefaultConnectionLimit = 12

        CloudStorageAccount.SetConfigurationSettingPublisher(Sub(configName, configSetter)
                                                                 configSetter(RoleEnvironment.GetConfigurationSettingValue(configName))
                                                                 AddHandler RoleEnvironment.Changed, Sub(sender, arg)
                                                                                                         If arg.Changes.OfType(Of RoleEnvironmentConfigurationSettingChange)().Any(Function(change) (change.ConfigurationSettingName = configName)) Then
                                                                                                             If Not configSetter(RoleEnvironment.GetConfigurationSettingValue(configName)) Then
                                                                                                                 RoleEnvironment.RequestRecycle()
                                                                                                             End If
                                                                                                         End If
                                                                                                     End Sub
                                                             End Sub)

        ' For information on handling configuration changes
        ' see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.

        Return MyBase.OnStart()
    End Function

    Public Sub TransferPerfDataToSql()
        Dim account = CloudStorageAccount.FromConfigurationSetting("Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString")
        Dim context = New PerformanceDataContext(account.TableEndpoint.ToString(), account.Credentials)
        Dim data = context.PerfData
        Dim pde As New PerfDataEntities()



        'Get average cpu
        Dim selectedData As List(Of PerformanceData) = (
            From d In data
            Where d.CounterName = "\Processor(_Total)\% Processor Time"
            Select d).ToList()

        Dim AvgCPU As Double = (
            From d In selectedData
            Where d.CounterName = "\Processor(_Total)\% Processor Time"
            Select d.CounterValue).Average()

        For Each perfdata As PerformanceData In selectedData
            context.DeleteObject(perfdata)
        Next perfdata

        context.SaveChanges()

        'get mem
        'TODO: change perf counter in code
        selectedData = (
            From d In data
            Where d.CounterName = "\.NET CLR Memory(_Global_)\% Time in GC"
            Select d).ToList()

        Dim AvgTimeGC As Double = (
            From d In selectedData
            Where d.CounterName = "\.NET CLR Memory(_Global_)\% Time in GC"
            Select d.CounterValue).Average()

        For Each perfdata As PerformanceData In selectedData
            context.DeleteObject(perfdata)
        Next perfdata

        context.SaveChanges()


        'TODO: create target SQL - done
        'TODO: insert data into SQL
        Dim cd As New CounterData()
        cd.CounterName = "\Processor(_Total)\% Processor Time"
        cd.CounterValue = CSng(AvgCPU)
        cd.TimeStamp = Date.Now.ToString()

        pde.AddToCounterDatas(cd)

        cd = New CounterData()
        cd.CounterName = "\.NET CLR Memory(_Global_)\% Time in GC"
        cd.CounterValue = CSng(AvgTimeGC)
        cd.TimeStamp = Date.Now.ToString()

        pde.AddToCounterDatas(cd)
        pde.SaveChanges()
        context.SaveChanges()
    End Sub
End Class